<?

  include_once("users.conf");
  require_once("utils.inc");

  if (phpversion() >= "4.2.1") { 
    ${$USER_COOKIE} = $_COOKIE{$USER_COOKIE};
  } 

  function getEditProfileURL($user) {
    global $USERS_BASE_URL;
    return "$USERS_BASE_URL/users_edit.php?id=$user->id&returnto=".urlencode(returnto_url());
  }
  function getProfileURL($user) {
    global $USERS_BASE_URL;
    return "$USERS_BASE_URL/profile.php?id=".$user->id."&returnto=".urlencode(returnto_url());
  }
  function getLoginURL() {
    global $USERS_BASE_URL;
    return "$USERS_BASE_URL/login.php?returnto=".urlencode(returnto_url());
  }
  function getLogoffURL() {
    global $USERS_BASE_URL;
    return "$USERS_BASE_URL/logoff.php?returnto=".urlencode(returnto_url());
  }
  function getForgotPasswordURL() {
    global $USERS_BASE_URL;
    return "$USERS_BASE_URL/forgotpassword.php?returnto=".urlencode(returnto_url());
  }
  function getNewUserURL() {
    global $USERS_BASE_URL;
    return "$USERS_BASE_URL/newaccount.php?returnto=".urlencode(returnto_url());
  }

  function connect_to_users_db() {
    global $USERS_DBHOST,$USERS_DB, $USERS_DBUSER, $USERS_DBPASS;

    if (!mysql_connect($USERS_DBHOST, $USERS_DBUSER, $USERS_DBPASS)) {
      // couldn't connect
       echo "could not connect ($USERS_DBHOST, $USERS_DBUSER, $USERS_DBPASS)"; 	
    }
    if (!mysql_select_db($USERS_DB)) {
      // couldn't connect
       echo "could not select ($USERS_DB)"; 	
    }
  }

  function send_confirmation($email,$token) {
    global $COMPANY_NAME,$USERS_BASE_URL,$WEB_MASTER,$WEB_MASTER_EMAIL;
    mail($email, "Welcome to $COMPANY_NAME", "Thank you for signing up. This email has been sent to you automatically. Please click the link below in order to confirm your account.\n\n$USERS_BASE_URL/confirm_account.php?token=".base64_encode($token)."\n\nEmail: $email\nToken: ".base64_encode($token)."\n\nThanks,\n$WEB_MASTER","From: $WEB_MASTER <$WEB_MASTER_EMAIL>\n");    
  }

  class User {
    var $id;
    var $email;
    var $seclev;
    var $status;
 
    function isAdmin() {
      return ($this->utype == "admin");
    }

    function load_from_db() {
      global $USERS_DB;
      $sql = "SELECT email,status,seclev FROM $USERS_DB.Users WHERE userId=".$this->id;
      $query = mysql_query($sql) or die ("The query failed! (".mysql_error()."): $sql"); 
      if ($query && (mysql_num_rows($query) > 0)) {
        list($this->email,$this->status,$this->seclev) = mysql_fetch_row($query);
      }
    }

    function init() {
      global $USER_COOKIE;
      global ${$USER_COOKIE};

      global $COOKIE_KEY;
      $cookie = ${$USER_COOKIE};

      if (isset($COOKIE_KEY)) {
        $iv = mcrypt_create_iv(mcrypt_get_iv_size (MCRYPT_BLOWFISH, MCRYPT_MODE_ECB), MCRYPT_RAND);
        $cookie = mcrypt_decrypt(MCRYPT_BLOWFISH, $COOKIE_KEY, base64_decode($cookie), MCRYPT_MODE_ECB, $iv);
      }
      $cookie = rtrim($cookie);

      $a = split('&', $cookie);
      $i = 0;
      while ($i < count($a)) {
        $b = split ('=', $a[$i]);
        $key = urldecode($b[0]);
        $value = urldecode($b[1]);
        $this->{$key} = $value;
        $i++;
      }
      $this->id = $this->{'uid'};
    }

    function set_user_cookie() {
      global $USER_COOKIE,$COOKIE_PATH,$COOKIE_DOMAIN;
      global $COOKIE_KEY;
      $cookie = "email=".urlencode($this->email)."&uid=$this->id&seclev=$this->seclev";
      if (isset($COOKIE_KEY)) {
        $iv = mcrypt_create_iv(mcrypt_get_iv_size (MCRYPT_BLOWFISH, MCRYPT_MODE_ECB), MCRYPT_RAND);
        $cookie = base64_encode(mcrypt_encrypt (MCRYPT_BLOWFISH, $COOKIE_KEY, $cookie, MCRYPT_MODE_ECB, $iv));
      }
      $expire = (time() + (3600 * 24 * 365 * 5));
      setcookie("$USER_COOKIE","$cookie","$expire","$COOKIE_PATH","$COOKIE_DOMAIN",0);
    }

    function unset_user_cookie() {
      global $USER_COOKIE,$COOKIE_PATH,$COOKIE_DOMAIN;
      setcookie($USER_COOKIE,"",time() - 3600,"$COOKIE_PATH","$COOKIE_DOMAIN");
    }

  }

  $user = new User; 
  $IS_LOGGED_IN = 0;
  if (isset(${$USER_COOKIE})) {
    $IS_LOGGED_IN = 1;
    $user->init();
  }
?>
